#include <stdio.h>
#define BUFFER_SIZE 4096

/*   length[] (output only):  three 8-byte integers describing length of file;
     length[0] = length of text header in bytes,
     length[1] = number of data entries or "wavelength bins"
                  = 1/4 number of bytes in data section
     length[2] = total number of bytes found in file;  if this
             is larger than length[0] + 4*length[1], then probably
             something is wrong with some data values(?)
      The length[] parameters are found by the function;  the
      function does not use them as input arguments. 
 */

int getdata( char *filen, long *filength, double *data )   {
	FILE	*fd;
	int		returnval=0, o, n;
	char	buffer[BUFFER_SIZE];
	float	buf[4];

	if ( (fd = fopen(filen,"r") ) == NULL ) {
		returnval = -100; 
     	/* returnval = -100 means "file can't be opened" */
	}

	if (returnval >= 0) {
		/* throw away header since we don't need it */
  		o = fread( &buffer[0], filength[0], 1, fd ); 
		o = filength[0] * o;
		if( o != filength[0] ) {
			returnval = -90;
       		/* returnval = -90 means "can't read the file" */
		}
		for( n=0; n<filength[1]; ++n ) {
    		o = fread( &buf[0],4, 1, fd );
			o = 4 * o;
			if( o != 4 ) {
				returnval = -90;
				break;
       			/* returnval = -90 means "can't read the file" */
			}
			data[n] = buf[0];
		}
 	}
  	fclose(fd);
	return( returnval );
}
