#include <math.h>
#include <stdio.h>
void integrate( double a, double b, double dx, double sl, double in, double *data, double cont_inter, double cont_slope, double *sums ) {
	double	n     = 0;	/* counter that goes from a to b for integration */
	int		s     = 0;	/* sample number of current n */
	int		intwidth=0,	
			grornet=0;
	double	nwidth=0.,
			afactor=0.,
			aa=0.,
			bb=0.,
			c=0.,
			d=0.,
			xa=0.,
			twoxb=0.,
			xc=0.,
			ya=0.,
			twoyb=0.,
			yc=0.,
			yasq=0.,
			ycsq=0.,
			xya=0.,
			xyc=0.,
			sumy=0.,
			sumysq=0.,
			sumxy=0.;

	if( a==0 || b==0 ) {
		printf( "You must set the limits of integration first!\n" );
		return;
	}

	intwidth = (int)(b - a);  nwidth = intwidth;  
	if (intwidth > 0) afactor = 0.5/nwidth;  else afactor = 0.;

  /* Do the "gross" and "net" sums separately: */
	for (grornet=0;grornet<=3;grornet=grornet+3) {
    	sumy = 0.;  sumysq = 0.;  sumxy = 0.;
		for( n=a+dx; n<=b; n+=dx ) {
			xa = xc;  ya = yc;  yasq = ycsq;  xya = xyc; 

			/* get sample number for current wavelength */
			s = (int)ceil((sl*n)+in);
			xc = n;
			yc = data[s];
   	   
   	   		if (grornet)  yc = yc - cont_inter - cont_slope*xc;
   	          /* (Above: "net" rather than "gross" y's) */
   	   		ycsq = yc*yc; xyc = xc*yc;
   	     	sumy = sumy + ya + yc;
   	     	sumysq = sumysq + yasq + ycsq; 
   	     	twoxb = xa + xc;  twoyb = ya + yc;   
   	     	sumxy = sumxy + xya + twoxb*twoyb + xyc;  
		}
    	aa = 0.;
    	if (sumy) aa = sumxy/(3.*sumy);  /* 1/3 because diff integration scheme */
    	sums[grornet+2] = aa;   /*  y-weighted <x>  */

    	aa = afactor*sumy;  
    	sums[grornet] = aa;   /*   <y>   */  

    	bb = afactor*sumysq;         /*  <y^2>  */
    	d = 0.;
    	c = bb - aa*aa;   if (c > 0.) d = sqrt(c);
    	sums[grornet+1] = d;    /* rms dev,  sqrt(<y - <y>>^2) */
	}
	return;
}
