#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>

void get_date_time(char* datebuf, char* timebuf, int format);

FILE	*fp;

int openlog( char* filename ) {
	if( fp != NULL )
		return( 0 );

	fp = fopen( filename, "a" );
	if( fp == NULL )
		return( 1 );
	else
		return( 0 );
}

int closelog() {
	if( fp != NULL )
		return( fclose( fp ) );
	else
		return( 0 );	
}

int writelog( char* text ) {
	int		rtn = 0;
    char	thedate[12],
			thetime[10];

	if( fp == NULL )
		return( 0 );
	get_date_time((char *)&thedate, (char *)&thetime, 0);
	rtn = fprintf( fp, "[ %s %s ] (%li) : %s\n", thedate, thetime, (long)getpid(), text );
	fflush( fp );
	if( rtn > 0 )
		return( 0 );
	else
		return( 1 );
}

void get_date_time(char* datebuf, char* timebuf, int format) {
	time_t		now;
	int			year,
				month;
	struct tm	*mytime;

	now = time(NULL);
	if (now == -1)
		return;

	mytime = localtime(&now);
	year = mytime->tm_year + 1900;
	month = mytime->tm_mon + 1;
	sprintf( datebuf, "%02i/%02i/%04i", month, mytime->tm_mday, year);
	sprintf( timebuf, "%02i:%02i:%02i", mytime->tm_hour, mytime->tm_min, mytime->tm_sec );
/*	free(mytime); */
	return;
}
